<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'
import { OPERATION_TYPE_LIST,RULE_TYPE_LIST } from '../constants';

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'modelCode',
    label: '模型编码 ',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'beginDate',
    label: '开始日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'endDate',
    label: '结束日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dscode',
    label: '数据源',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'storeType',
    label: '规则类型',
    component: 'Select',
    componentProps: {
      options:RULE_TYPE_LIST
    },
    value:'1'
  },
  {
    field: 'storeContent',
    label: '规则内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'storeOperateType',
    label: '操作类型',
    component: 'Select',
    componentProps: {
      options:OPERATION_TYPE_LIST
    },
    value:'1'
  },
  {
    field: 'ruleId',
    label: '存储规则id',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'schema',
    label: '数据库用户',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'tableName',
    label: '表名',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'validateResultTable',
    label: '校验结果表的表名',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'dataRule',
    label: '数据规则',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'redscode',
    label: '备份数据源',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  modelCode: [required()],
  beginDate: [required()],
  endDate: [required()],
  ruleId: [required()],
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

